/*
*  AQUARIUM - manage taquanag
*/

#include "aquarium.ch"

/*
* p005Frm definition
*/
FUNCTION p005Frm_Define()

SET NAVIGATION EXTENDED
DEFINE WINDOW p005Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 860 ;
 HEIGHT 645 ;
 WINDOWTYPE STANDARD ;
 TITLE "Aquarium MANAGER (p005Frm)" ;
 ICON "MAIN_ICO" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE p005Frm_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION p005_Exit() ;
   SEPARATOR
  BUTTON btSave ;
   CAPTION '&Save' ;
   PICTURE "BTSAVE" ;
   ACTION p005_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* E=empty form, 0=form in use and record not found, 1=form in use and record found and lock, 2=form in use and record found and lock and already deleted
 DEFINE LABEL FormStatus
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "E"
  VISIBLE .F.
 END LABEL

* label taqidcode
 DEFINE LABEL lb_taqidcode
  ROW 60
  COL 20
  VALUE 'Code'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Code'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqidcode
 DEFINE TEXTBOX taqidcode
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE ""
  READONLY .F.
  INPUTMASK Nil
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Code'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE CHARACTER
  MAXLENGTH 8
  CASECONVERT UPPER
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p005_Enter()
  RIGHTALIGN .F.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqdescri
 DEFINE LABEL lb_taqdescri
  ROW 90
  COL 20
  VALUE 'Description'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Description'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqdescri
 DEFINE EDITBOX taqdescri
  ROW 90
  COL 125
  HEIGHT 100
  WIDTH 300
  VALUE ""
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Description'
  MAXLENGTH 255
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  TABSTOP .T.
  VISIBLE .T.
  READONLY .F.
  VSCROLLBAR .T.
  HSCROLLBAR .F.
 END EDITBOX

 DEFINE IMAGE ImgAqua
  ROW 90
  COL 500
  ONCLICK Nil
  PICTURE "Images/aquarium.jpg"
  WIDTH 343
  HEIGHT 345
  STRETCH .F.
  VISIBLE .T.
 END IMAGE

* label W
 DEFINE LABEL lb_W
  ROW 210
  COL 125
  VALUE 'Width cm'
  ONCLICK  Nil
  WIDTH 80
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'W cm'
  BACKCOLOR {153,204,204}
  FONTCOLOR Nil
  TRANSPARENT .F.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL

* label H
 DEFINE LABEL lb_H
  ROW 210
  COL 225
  VALUE 'Height cm'
  ONCLICK  Nil
  WIDTH 80
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'H cm'
  BACKCOLOR {153,204,204}
  FONTCOLOR Nil
  TRANSPARENT .F.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL

* label D
 DEFINE LABEL lb_D
  ROW 210
  COL 325
  VALUE 'Depth cm'
  ONCLICK  Nil
  WIDTH 80
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'D cm'
  BACKCOLOR {153,204,204}
  FONTCOLOR Nil
  TRANSPARENT .F.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL

* label taqextwid
 DEFINE LABEL lb_taqextwid
  ROW 240
  COL 20
  VALUE 'Ext. dim.'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Ext. dim.'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqextwid
 DEFINE TEXTBOX taqextwid
  ROW 240
  COL 125
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Width'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqextwid()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* label x01
 DEFINE LABEL lb_x01
  ROW 240
  COL 210
  VALUE 'X'
  ONCLICK  Nil
  WIDTH 10
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .T.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP Nil
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field taqexthei
 DEFINE TEXTBOX taqexthei
  ROW 240
  COL 225
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Height'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqexthei()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* label x02
 DEFINE LABEL lb_x02
  ROW 240
  COL 310
  VALUE 'X'
  ONCLICK  Nil
  WIDTH 10
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .T.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP Nil
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field taqextdep
 DEFINE TEXTBOX taqextdep
  ROW 240
  COL 325
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Depth'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqextdep()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqglswid
 DEFINE LABEL lb_taqglswid
  ROW 270
  COL 20
  VALUE 'Thick Glass'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Thick Glass'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqglswid
 DEFINE TEXTBOX taqglswid
  ROW 270
  COL 125
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '9.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Thick Glass on Width'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqglswid()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* field taqglshei
 DEFINE TEXTBOX taqglshei
  ROW 270
  COL 225
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '9.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Thick Glass on Eight'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqglshei()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* field taqglsdep
 DEFINE TEXTBOX taqglsdep
  ROW 270
  COL 325
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '9.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Thick Glass on Depth'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqglsdep()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqtopmrg
 DEFINE LABEL lb_taqtopmrg
  ROW 300
  COL 20
  VALUE 'Water Top Margin'
  ONCLICK  Nil
  WIDTH 200
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Water Top Margin'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field taqtopmrg
 DEFINE TEXTBOX taqtopmrg
  ROW 300
  COL 225
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '9.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Water Top Margin'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqtopmrg()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqthkbot
 DEFINE LABEL lb_taqthkbot
  ROW 330
  COL 20
  VALUE 'Thick bottom'
  ONCLICK  Nil
  WIDTH 200
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Thick bottom'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field taqthkbot
 DEFINE TEXTBOX taqthkbot
  ROW 330
  COL 225
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '9.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Thick bottom'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqthkbot()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqfltwid
 DEFINE LABEL lb_taqfltwid
  ROW 360
  COL 20
  VALUE 'Filter volume'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Filter volume'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqfltwid
 DEFINE TEXTBOX taqfltwid
  ROW 360
  COL 125
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Width'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqfltwid()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* label x01
 DEFINE LABEL lb_y01
  ROW 360
  COL 210
  VALUE 'X'
  ONCLICK  Nil
  WIDTH 10
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .T.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP Nil
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field taqflthei
 DEFINE TEXTBOX taqflthei
  ROW 360
  COL 225
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Height'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqflthei()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* label x02
 DEFINE LABEL lb_y02
  ROW 360
  COL 310
  VALUE 'X'
  ONCLICK  Nil
  WIDTH 10
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .T.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP Nil
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field taqfltdep
 DEFINE TEXTBOX taqfltdep
  ROW 360
  COL 325
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999.9'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Depth'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqfltdep()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqrocvol
 DEFINE LABEL lb_taqrocvol
  ROW 390
  COL 20
  VALUE 'Rocks volume'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Rocks volume'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqrocvol
 DEFINE TEXTBOX taqrocvol
  ROW 390
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE 0
  READONLY .F.
  INPUTMASK '999,999.99'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Rocks vol.'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqrocvol()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqothvol
 DEFINE LABEL lb_taqothvol
  ROW 420
  COL 20
  VALUE 'Other vol.'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Other vol.'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqothvol
 DEFINE TEXTBOX taqothvol
  ROW 420
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE 0
  READONLY .F.
  INPUTMASK '999,999.99'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Other vol.'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p005_chgvalues()
  ONLOSTFOCUS Nil
  ONENTER p005_taqothvol()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqnetvol
 DEFINE LABEL lb_taqnetvol
  ROW 450
  COL 20
  VALUE 'Net Volume'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Net Volume'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqnetvol
 DEFINE TEXTBOX taqnetvol
  ROW 450
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE 0
  READONLY .T.
  INPUTMASK '999,999,999.99'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Net. Volume'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER Nil
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR DISBCKCLR
 END TEXTBOX

* label taqnetlit
 DEFINE LABEL lb_taqnetlit
  ROW 450
  COL 240
  VALUE 'Net Liters'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Net Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqnetlit
 DEFINE TEXTBOX taqnetlit
  ROW 450
  COL 345
  HEIGHT 25
  WIDTH 100
  VALUE 0
  READONLY .T.
  INPUTMASK '999,999.99'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Net Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER Nil
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR DISBCKCLR
 END TEXTBOX

* label taqlgtwat
 DEFINE LABEL lb_taqlgtwat
  ROW 480
  COL 20
  VALUE 'Light Watt'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Light Watt estimated on net Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqlgtwat
 DEFINE TEXTBOX taqlgtwat
  ROW 480
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE 0
  READONLY .T.
  INPUTMASK '999,999'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Light Watt estimated on net Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER Nil
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR DISBCKCLR
 END TEXTBOX

* label taqpmplth
 DEFINE LABEL lb_taqpmplth
  ROW 480
  COL 240
  VALUE 'Pump l/h'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'l/h estimated on net Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqpmplth
 DEFINE TEXTBOX taqpmplth
  ROW 480
  COL 345
  HEIGHT 25
  WIDTH 100
  VALUE 0
  READONLY .T.
  INPUTMASK '9,999,999'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'l/h estimated on net Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER Nil
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR DISBCKCLR
 END TEXTBOX

* label taqchgday
 DEFINE LABEL lb_taqchgday
  ROW 540
  COL 20
  VALUE 'Change water every'
  ONCLICK  Nil
  WIDTH 200
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Change water every'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqchgday
 DEFINE TEXTBOX taqchgday
  ROW 540
  COL 225
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Days number'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p005_taqchgday()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label taqchgper
 DEFINE LABEL lb_taqchgper
  ROW 540
  COL 310
  VALUE 'Water in %'
  ONCLICK  Nil
  WIDTH 200
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Water in %'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field taqchgper
 DEFINE TEXTBOX taqchgper
  ROW 540
  COL 515
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP '% water'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p005_taqchgper()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

END WINDOW

p005Frm.Center
RETURN NIL

/****************************************************************
* pgm002 Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p005_Main( aParm, nGrid)
LOCAL lReturn := .F.
IF IsFomFree( "p005Frm", "FormStatus", "E" )
 p005_ShowForm( aParm, nGrid)
 lReturn := .T.
ELSE
 p005_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* Show form
****************************************************************/
STATIC FUNCTION p005_ShowForm( aParm, nGrid)
LOCAL aTemp := {}
PUBLIC p005_nGrid := IF( VALTYPE( nGrid ) == "N", nGrid, 0 )
PUBLIC p005_aParm := IF( VALTYPE( aParm ) == "A", aParm, {} )
p005_FormInit()
p005Frm.Restore
p005Frm.Setfocus

IF p005_nGrid <> 0
 aTemp := GetProperty("p004Frm", "grid1", "item", p005_nGrid)
 p005Frm.taqidcode.Value := aTemp[1]
ELSE
 p005Frm.taqidcode.Value := "xxxxxxxx"
ENDIF
p005Frm.taqidcode.SetFocus
p005_Enter()

RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p005_aParm is declared PUBLIC inside in p005_ShowForm function
* but p005_NewFocus can be called from p005_Main and p005_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p005_NewFocus( aParm )
LOCAL aNewFocus := IF( VALTYPE( aParm ) == "A", aParm, IF( __MVEXIST("p005_aParm"), __MVGET("p005_aParm"), {} ) )
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p005_aParm")
 __MVPUT("p005_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* p005Frm OnIntercativeClose event
****************************************************************/
STATIC FUNCTION p005Frm_OnIntClose()
p005_FormReset()
p005_NewFocus()
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p005_FormReset()
taquanag->(DBUNLOCK())
p005_FormInit()
RETURN NIL

/****************************************************************
* Form Init function
****************************************************************/
STATIC FUNCTION p005_FormInit()
p005Frm.FormStatus.Value := "E"
p005Frm.taqidcode.Value := ""
p005Frm.taqdescri.Value := ""
p005Frm.taqextwid.Value := 0
p005Frm.taqexthei.Value := 0
p005Frm.taqextdep.Value := 0
p005Frm.taqglswid.Value := 0
p005Frm.taqglshei.Value := 0
p005Frm.taqglsdep.Value := 0
p005Frm.taqtopmrg.Value := 0
p005Frm.taqthkbot.Value := 0
p005Frm.taqfltwid.Value := 0
p005Frm.taqflthei.Value := 0
p005Frm.taqfltdep.Value := 0
p005Frm.taqrocvol.Value := 0
p005Frm.taqothvol.Value := 0
p005Frm.taqnetvol.Value := 0
p005Frm.taqnetlit.Value := 0
p005Frm.taqlgtwat.Value := 0
p005Frm.taqpmplth.Value := 0
p005Frm.taqchgper.Value := 20
p005Frm.taqchgday.Value := 15

AllDisabled( "p005Frm", {"taqdescri","taqextwid","taqexthei","taqextdep","taqglswid","taqglshei","taqglsdep","taqtopmrg","taqthkbot","taqfltwid","taqflthei","taqfltdep","taqrocvol","taqothvol","taqnetvol","taqnetlit","taqchgper","taqchgday"} )
p005Frm.taqidcode.Enabled := .T.
p005Frm.taqidcode.SetFocus

p005Frm.btSave.Enabled := .F.

RETURN NIL

/****************************************************************
* Exit event
****************************************************************/
STATIC FUNCTION p005_Exit()
p005_FormReset()
p005Frm.Hide
p005_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p005_Save()
IF p005_CheckData() == .T.
 IF p005_Update()
  p005_FormReset()
  p005Frm.Hide
  p005_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p005_Enter()
IF p005_taqidcode() == .T.
 p005_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Retrieve record
****************************************************************/
STATIC FUNCTION p005_Getrec()
LOCAL cKey := FillKey( p005Frm.taqidcode.Value, 8 )

taquanag->(ORDSETFOCUS(1))
IF taquanag->(DBSEEK(cKey, .F.)) == .T.
 IF Reclock("taquanag") == .T.
  p005Frm.FormStatus.Value := "1"
  IF taquanag->(DELETED())
   p005Frm.FormStatus.Value := "2"
  ENDIF
  p005_LoadForm()
 ELSE
  MSGSTOP("Record LOCKED","p005_Getrec()")
 ENDIF
ELSE
 p005Frm.FormStatus.Value := "0"
 p005_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p005_LoadForm()
IF p005Frm.FormStatus.Value <> "0"
 p005Frm.taqdescri.Value := taquanag->taqdescri
 p005Frm.taqextwid.Value := taquanag->taqextwid
 p005Frm.taqexthei.Value := taquanag->taqexthei
 p005Frm.taqextdep.Value := taquanag->taqextdep
 p005Frm.taqglswid.Value := taquanag->taqglswid
 p005Frm.taqglshei.Value := taquanag->taqglshei
 p005Frm.taqglsdep.Value := taquanag->taqglsdep
 p005Frm.taqtopmrg.Value := taquanag->taqtopmrg
 p005Frm.taqthkbot.Value := taquanag->taqthkbot
 p005Frm.taqfltwid.Value := taquanag->taqfltwid
 p005Frm.taqflthei.Value := taquanag->taqflthei
 p005Frm.taqfltdep.Value := taquanag->taqfltdep
 p005Frm.taqrocvol.Value := taquanag->taqrocvol
 p005Frm.taqothvol.Value := taquanag->taqothvol
 p005Frm.taqnetvol.Value := taquanag->taqnetvol
 p005Frm.taqnetlit.Value := taquanag->taqnetlit
 p005Frm.taqlgtwat.Value := taquanag->taqlgtwat
 p005Frm.taqpmplth.Value := taquanag->taqpmplth
 p005Frm.taqchgday.Value := taquanag->taqchgday
 p005Frm.taqchgper.Value := taquanag->taqchgper
 p005_chgvalues()
ENDIF
p005Frm.taqidcode.Enabled := .F.
AllEnabled( "p005Frm", {"taqdescri","taqextwid","taqexthei","taqextdep","taqglswid","taqglshei","taqglsdep","taqtopmrg","taqthkbot","taqfltwid","taqflthei","taqfltdep","taqrocvol","taqothvol","taqnetvol","taqnetlit","taqchgper","taqchgday"} )
p005Frm.taqdescri.SetFocus

p005Frm.btSave.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p005_Update()
LOCAL lDone := .T., lRiattiva := .F., nValCode := 0
IF p005Frm.FormStatus.Value == "0"
 IF p003_getprogr("LSTAQUAR", @nValCode) == .T.
  p005Frm.taqidcode.Value := STRTRAN( STR(nValCode, 8, 0 ), " ", "0" )
 ELSE
  MSGSTOP( "Can't add new record","p005_update()")
  lDone := .F.
 ENDIF
ENDIF

IF p005Frm.FormStatus.Value == "0" .AND. lDone == .T. .AND. Addrec("taquanag") == .F.
 MSGSTOP( "Can't add new record","p005_update()")
 lDone:=.F.
ENDIF
IF p005Frm.FormStatus.Value == "2"
 lRiattiva := MSGYESNO("Reactivate record?" )
ENDIF
IF lDone == .T.
 taquanag->admintstp := HB_TTOS(HB_DATETIME())
 IF p005Frm.FormStatus.Value == "0"
  taquanag->taqidcode := p005Frm.taqidcode.Value
 ENDIF
 taquanag->taqdescri := p005Frm.taqdescri.Value
 taquanag->taqextwid := p005Frm.taqextwid.Value
 taquanag->taqexthei := p005Frm.taqexthei.Value
 taquanag->taqextdep := p005Frm.taqextdep.Value
 taquanag->taqglswid := p005Frm.taqglswid.Value
 taquanag->taqglshei := p005Frm.taqglshei.Value
 taquanag->taqglsdep := p005Frm.taqglsdep.Value
 taquanag->taqtopmrg := p005Frm.taqtopmrg.Value
 taquanag->taqthkbot := p005Frm.taqthkbot.Value
 taquanag->taqfltwid := p005Frm.taqfltwid.Value
 taquanag->taqflthei := p005Frm.taqflthei.Value
 taquanag->taqfltdep := p005Frm.taqfltdep.Value
 taquanag->taqrocvol := p005Frm.taqrocvol.Value
 taquanag->taqothvol := p005Frm.taqothvol.Value
 taquanag->taqnetvol := p005Frm.taqnetvol.Value
 taquanag->taqnetlit := p005Frm.taqnetlit.Value
 taquanag->taqlgtwat := p005Frm.taqlgtwat.Value
 taquanag->taqpmplth := p005Frm.taqpmplth.Value
 taquanag->taqchgday := p005Frm.taqchgday.Value
 taquanag->taqchgper := p005Frm.taqchgper.Value
 IF p005Frm.FormStatus.Value == "2" .AND. lRiattiva
  taquanag->(DBRECALL())
 ENDIF
 p005_UpdGrid()
 taquanag->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Update p005grid1
****************************************************************/
STATIC FUNCTION p005_UpdGrid()
* IF p005_nGrid == 0 must be added else update
IF p005_nGrid == 0
 aTemp := {"", "", 0}
ELSE
 aTemp := GetProperty( "p004Frm", "grid1", "item", p005_nGrid )
ENDIF
aTemp[1] := p005Frm.taqidcode.Value
aTemp[2] := p005Frm.taqdescri.Value
aTemp[3] := p005Frm.taqchgday.Value
* IF p005_nGrid == 0 must be added else update
IF p005_nGrid == 0
 DoMethod("p004Frm", "grid1", "additem", aTemp)
 p005_nGrid := GetProperty("p004Frm", "grid1", "ItemCount")
 SetProperty("p004Frm", "grid1", "Value", p005_nGrid )
ELSE
 SetProperty( "p004Frm", "grid1", "item", p005_nGrid, aTemp )
ENDIF

RETURN NIl

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p005_CheckData()
LOCAL lItsOk := .T.
*lItsOk := IF(lItsOk==.T., p005_taqidcode(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqdescri(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqextwid(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqexthei(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqextdep(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqglswid(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqglshei(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqglsdep(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqtopmrg(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqthkbot(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqfltwid(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqflthei(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqfltdep(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqrocvol(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqothvol(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqchgday(), lItsOk)
lItsOk := IF(lItsOk==.T., p005_taqchgper(), lItsOk)
RETURN lItsOk

/****************************************************************
* taqidcode error
****************************************************************/
STATIC FUNCTION p005_taqidcode()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p005Frm.taqidcode.Value ) ) == 0
 lItsOk := .F.
 MSGSTOP("Enter a valid code", "p005_taqidcode()")
 p005Frm.taqidcode.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqdescri error
****************************************************************/
STATIC FUNCTION p005_taqdescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p005Frm.taqdescri.Value)) == 0
  lItsOk := .F.
  MSGSTOP("Enter a valid description","p005_taqdescri()")
  p005Frm.taqdescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqextwid error
****************************************************************/
STATIC FUNCTION p005_taqextwid()
LOCAL lItsOk := .T.
IF p005Frm.taqextwid.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqextwid()")
  p005Frm.taqextwid.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqexthei error
****************************************************************/
STATIC FUNCTION p005_taqexthei()
LOCAL lItsOk := .T.
IF p005Frm.taqexthei.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqexthei()")
  p005Frm.taqexthei.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqextdep error
****************************************************************/
STATIC FUNCTION p005_taqextdep()
LOCAL lItsOk := .T.
IF p005Frm.taqextdep.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqextdep()")
  p005Frm.taqextdep.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqglswid error
****************************************************************/
STATIC FUNCTION p005_taqglswid()
LOCAL lItsOk := .T.
IF p005Frm.taqglswid.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqglswid()")
  p005Frm.taqglswid.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqglshei error
****************************************************************/
STATIC FUNCTION p005_taqglshei()
LOCAL lItsOk := .T.
IF p005Frm.taqglshei.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqglshei()")
  p005Frm.taqglshei.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqglsdep error
****************************************************************/
STATIC FUNCTION p005_taqglsdep()
LOCAL lItsOk := .T.
IF p005Frm.taqglsdep.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqglsdep()")
  p005Frm.taqglsdep.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqtopmrg error
****************************************************************/
STATIC FUNCTION p005_taqtopmrg()
LOCAL lItsOk := .T.
IF p005Frm.taqtopmrg.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqtopmrg()")
  p005Frm.taqtopmrg.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqthkbot error
****************************************************************/
STATIC FUNCTION p005_taqthkbot()
LOCAL lItsOk := .T.
IF p005Frm.taqthkbot.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqthkbot()")
  p005Frm.taqthkbot.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqfltwid error
****************************************************************/
STATIC FUNCTION p005_taqfltwid()
LOCAL lItsOk := .T.
IF p005Frm.taqfltwid.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqfltwid()")
  p005Frm.taqfltwid.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqflthei error
****************************************************************/
STATIC FUNCTION p005_taqflthei()
LOCAL lItsOk := .T.
IF p005Frm.taqflthei.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqflthei()")
  p005Frm.taqflthei.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqfltdep error
****************************************************************/
STATIC FUNCTION p005_taqfltdep()
LOCAL lItsOk := .T.
IF p005Frm.taqfltdep.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqfltdep()")
  p005Frm.taqfltdep.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqrocvol error
****************************************************************/
STATIC FUNCTION p005_taqrocvol()
LOCAL lItsOk := .T.
IF p005Frm.taqrocvol.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqrocvol()")
  p005Frm.taqrocvol.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqothvol error
****************************************************************/
STATIC FUNCTION p005_taqothvol()
LOCAL lItsOk := .T.
IF p005Frm.taqothvol.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqothvol()")
  p005Frm.taqothvol.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqchgday error
****************************************************************/
STATIC FUNCTION p005_taqchgday()
LOCAL lItsOk := .T.
IF p005Frm.taqchgday.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqchgday()")
  p005Frm.taqchgday.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* taqchgper error
****************************************************************/
STATIC FUNCTION p005_taqchgper()
LOCAL lItsOk := .T.
IF p005Frm.taqchgper.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p005_taqchgper()")
  p005Frm.taqchgper.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* calculate values
****************************************************************/
STATIC FUNCTION p005_chgvalues()
LOCAL nWidth := 0, nHeight := 0, nDepth := 0, nVolume := 0, nFltVol := 0
IF p005Frm.FormStatus.Value <> "E"
* create internal dimensions
 nWidth := p005Frm.taqextwid.Value - p005Frm.taqglswid.Value
 nHeight := p005Frm.taqexthei.Value - p005Frm.taqglshei.Value - p005Frm.taqtopmrg.Value - p005Frm.taqthkbot.Value
 nDepth := p005Frm.taqextdep.Value - p005Frm.taqglsdep.Value
* calculate gross volume
 nVolume := nWidth * nHeight * nDepth
* calculate filter volume
 nFltVol := ROUND( p005Frm.taqfltwid.Value * p005Frm.taqflthei.Value * p005Frm.taqfltdep.Value, 2 )
* net volume
 nVolume := ROUND( nVolume - nFltVol - p005Frm.taqrocvol.Value - p005Frm.taqothvol.Value, 2 )
 p005Frm.taqnetvol.Value := nVolume
* net liters
 p005Frm.taqnetlit.Value := ROUND( nVolume / 1000, 2 )
* light Watt estimated on net liters / 4
 p005Frm.taqlgtwat.Value := ROUND( p005Frm.taqnetlit.Value / 4, 0 )
* pump l/h estimated on net liters * 3 [ or 2.5 ?]
 p005Frm.taqpmplth.Value := ROUND( p005Frm.taqnetlit.Value * 3, 0 )
ENDIF
RETURN Nil

/****************************************************************
* public functions
****************************************************************/

/****************************************************************
* return record
****************************************************************/
FUNCTION p005_GetRecord( nGrid )
LOCAL nCurOrd := taquanag->(ORDSETFOCUS(1)), nCurRec := taquanag->(RECNO())
LOCAL cKey := FillKey(nGrid, 8 )
LOCAL aRetFields := {"","",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}

IF taquanag->(DBSEEK( cKey, .F. ) ) == .T.
 aRetFields[01] := taquanag->taqidcode
 aRetFields[02] := taquanag->taqdescri
 aRetFields[03] := taquanag->taqextwid
 aRetFields[04] := taquanag->taqexthei
 aRetFields[05] := taquanag->taqextdep
 aRetFields[06] := taquanag->taqglswid
 aRetFields[07] := taquanag->taqglshei
 aRetFields[08] := taquanag->taqglsdep
 aRetFields[09] := taquanag->taqtopmrg
 aRetFields[10] := taquanag->taqthkbot
 aRetFields[11] := taquanag->taqfltwid
 aRetFields[12] := taquanag->taqflthei
 aRetFields[13] := taquanag->taqfltdep
 aRetFields[14] := taquanag->taqrocvol
 aRetFields[15] := taquanag->taqothvol
 aRetFields[16] := taquanag->taqnetvol
 aRetFields[17] := taquanag->taqnetlit
 aRetFields[18] := taquanag->taqlgtwat
 aRetFields[19] := taquanag->taqpmplth
 aRetFields[20] := taquanag->taqchgday
 aRetFields[21] := taquanag->taqchgper
ENDIF

taquanag->(ORDSETFOCUS(nCurOrd))
taquanag->(DBGOTO(nCurRec))

RETURN aRetFields