/*
*  AQUARIUM - manage chgwater
*/

#include "aquarium.ch"

/*
* p101Frm definition
*/
FUNCTION p101Frm_Define()

SET NAVIGATION EXTENDED
DEFINE WINDOW p101Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 860 ;
 HEIGHT 645 ;
 WINDOWTYPE STANDARD ;
 TITLE "Change Water MANAGER (p101Frm)" ;
 ICON "MAIN_ICO" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE p101Frm_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION p101_Exit() ;
   SEPARATOR
  BUTTON btSave ;
   CAPTION '&Save' ;
   PICTURE "BTSAVE" ;
   ACTION p101_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* E=empty form, 0=form in use and record not found, 1=form in use and record found and lock, 2=form in use and record found and lock and already deleted
 DEFINE LABEL FormStatus
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "E"
  VISIBLE .F.
 END LABEL

* label chwidaqua
 DEFINE LABEL lb_chwidaqua
  ROW 60
  COL 20
  VALUE 'Aquarium'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Aquarium'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field chwidaqua
 DEFINE TEXTBOX chwidaqua
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE ""
  READONLY .F.
  INPUTMASK Nil
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Aquarium'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE CHARACTER
  MAXLENGTH 8
  CASECONVERT UPPER
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p101_chwidaqua()
  RIGHTALIGN .F.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX
* button chwidaqua
 DEFINE BUTTON bt_chwidaqua
  ROW 60
  COL 230
  CAPTION Nil
  PICTURE "BTSEARCH"
  PICTALIGNMENT Top
  ONCLICK p101Src_chwidaqua()
  WIDTH 30
  HEIGHT 30
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Click to find'
  FLAT .T.
  TRANSPARENT .T.
  ONGOTFOCUS Nil
  ONLOSTFOCUS Nil
  TABSTOP .F.
  VISIBLE .T.
  MULTILINE .F.
 END BUTTON
* field taqdescri
 DEFINE TEXTBOX taqdescri
  ROW 60
  COL 265
  HEIGHT 25
  WIDTH 400
  VALUE ""
  READONLY .T.
  INPUTMASK Nil
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Aquarium'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE CHARACTER
  MAXLENGTH 8
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p101_chwidaqua()
  RIGHTALIGN .F.
  VISIBLE .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR DISBCKCLR
 END TEXTBOX

* label chwdatech
 DEFINE LABEL lb_chwdatech
  ROW 90
  COL 20
  VALUE 'Date'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Date'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field chwdatech
 DEFINE DATEPICKER chwdatech
  ROW 90
  COL 125
  WIDTH 110
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP "Data"
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  TABSTOP .T.
  VISIBLE .T.
  VALUE DATE()
  SHOWNONE .F.
  UPDOWN .F.
  RIGHTALIGN .F.
  ONENTER p101_Enter()
 END DATEPICKER

* label chwliters
 DEFINE LABEL lb_chwliters
  ROW 120
  COL 20
  VALUE 'Liters'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field chwliters
 DEFINE TEXTBOX chwliters
  ROW 120
  COL 125
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999,999.99'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Liters'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p101_chgvalues(1)
  ONLOSTFOCUS Nil
  ONENTER p101_chwliters()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label chwpercen
 DEFINE LABEL lb_chwpercen
  ROW 150
  COL 20
  VALUE '%'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP '%'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field chwpercen
 DEFINE TEXTBOX chwpercen
  ROW 150
  COL 125
  HEIGHT 25
  WIDTH 80
  VALUE 0
  READONLY .F.
  INPUTMASK '999'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP '%'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE p101_chgvalues(2)
  ONLOSTFOCUS Nil
  ONENTER p101_chwpercen()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label chwnotess
 DEFINE LABEL lb_chwnotess
  ROW 180
  COL 20
  VALUE 'Notes'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Notes'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Center
  VISIBLE .T.
 END LABEL
* field chwnotess
 DEFINE EDITBOX chwnotess
  ROW 180
  COL 125
  HEIGHT 100
  WIDTH 300
  VALUE ""
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Description'
  MAXLENGTH 255
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  TABSTOP .T.
  VISIBLE .T.
  READONLY .F.
  VSCROLLBAR .T.
  HSCROLLBAR .F.
 END EDITBOX

END WINDOW

p101Frm.Center
RETURN NIL

/****************************************************************
* pgm002 Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p101_Main( aParm, nGrid)
LOCAL lReturn := .F.
IF IsFomFree( "p101Frm", "FormStatus", "E" )
 p101_ShowForm( aParm, nGrid)
 lReturn := .T.
ELSE
 p101_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* Show form
****************************************************************/
STATIC FUNCTION p101_ShowForm( aParm, nGrid )
LOCAL aTemp := {}
PUBLIC p101_nGrid := IF( VALTYPE( nGrid ) == "N", nGrid, 0 )
PUBLIC p101_aParm := IF( VALTYPE( aParm ) == "A", aParm, {} )
p101_FormInit()
p101Frm.Restore
p101Frm.Setfocus

IF p101_nGrid <> 0
 aTemp := GetProperty("p100Frm", "grid1", "item", p101_nGrid)
 p101Frm.chwidaqua.Value := aTemp[1]
 p101Frm.chwdatech.Value := aTemp[3]
 p101Frm.chwidaqua.SetFocus
 p101_Enter()
ENDIF

RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p101_aParm is declared PUBLIC inside in p101_ShowForm function
* but p101_NewFocus can be called from p101_Main and p101_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p101_NewFocus( aParm )
LOCAL aNewFocus := IF( VALTYPE( aParm ) == "A", aParm, IF( __MVEXIST("p101_aParm"), __MVGET("p101_aParm"), {} ) )
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p101_aParm")
 __MVPUT("p101_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* p101Frm OnIntercativeClose event
****************************************************************/
STATIC FUNCTION p101Frm_OnIntClose()
p101_FormReset()
p101_NewFocus()
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p101_FormReset()
chgwater->(DBUNLOCK())
p101_FormInit()
RETURN NIL

/****************************************************************
* Form Init function
****************************************************************/
STATIC FUNCTION p101_FormInit()
p101Frm.FormStatus.Value := "E"
p101Frm.chwidaqua.Value := ""
p101Frm.taqdescri.Value := ""
p101Frm.chwdatech.Value := DATE()
p101Frm.chwliters.Value := 0
p101Frm.chwpercen.Value := 0
p101Frm.chwnotess.Value := ""

AllDisabled( "p101Frm", {"chwliters","chwpercen","chwnotess"} )
p101Frm.chwidaqua.Enabled := .T.
p101Frm.chwdatech.Enabled := .T.
p101Frm.chwidaqua.SetFocus

p101Frm.btSave.Enabled := .F.

RETURN NIL

/****************************************************************
* Exit event
****************************************************************/
STATIC FUNCTION p101_Exit()
p101_FormReset()
p101Frm.Hide
p101_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p101_Save()
IF p101_CheckData() == .T.
 IF p101_Update()
  p101_FormReset()
  p101Frm.Hide
  p101_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p101_Enter()
IF p101_chwidaqua() == .T.
 p101_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Retrieve record
****************************************************************/
STATIC FUNCTION p101_Getrec()
LOCAL cKey := FillKey( p101Frm.chwidaqua.Value, 8 ) + DTOS( p101Frm.chwdatech.Value )

chgwater->(ORDSETFOCUS(1))
IF chgwater->(DBSEEK(cKey, .F.)) == .T.
 IF Reclock("chgwater") == .T.
  p101Frm.FormStatus.Value := "1"
  IF chgwater->(DELETED())
   p101Frm.FormStatus.Value := "2"
  ENDIF
  p101_LoadForm()
 ELSE
  MSGSTOP("Record LOCKED","p101_Getrec()")
 ENDIF
ELSE
 p101Frm.FormStatus.Value := "0"
 p101_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p101_LoadForm()
IF p101Frm.FormStatus.Value <> "0"
 p101Frm.chwliters.Value := chgwater->chwliters
 p101Frm.chwpercen.Value := chgwater->chwpercen
 p101Frm.chwnotess.Value := chgwater->chwnotess
ENDIF

AllEnabled( "p101Frm", {"chwliters","chwpercen","chwnotess"} )
p101Frm.chwidaqua.Enabled := .F.
p101Frm.chwdatech.Enabled := .F.

p101Frm.chwliters.SetFocus

p101Frm.btSave.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p101_Update()
LOCAL lDone := .T., lRiattiva := .F., nValCode := 0

IF p101Frm.FormStatus.Value == "0" .AND. lDone == .T. .AND. Addrec("chgwater") == .F.
 MSGSTOP( "Can't add new record","p101_update()")
 lDone:=.F.
ENDIF
IF p101Frm.FormStatus.Value == "2"
 lRiattiva := MSGYESNO("Reactivate record?" )
ENDIF
IF lDone == .T.
 chgwater->admintstp := HB_TTOS(HB_DATETIME())
 IF p101Frm.FormStatus.Value == "0"
  chgwater->chwidaqua := p101Frm.chwidaqua.Value
  chgwater->chwdatech := DTOS(p101Frm.chwdatech.Value)
 ENDIF
 chgwater->chwliters := p101Frm.chwliters.Value
 chgwater->chwpercen := p101Frm.chwpercen.Value
 chgwater->chwnotess := p101Frm.chwnotess.Value
 IF p101Frm.FormStatus.Value == "2" .AND. lRiattiva
  chgwater->(DBRECALL())
 ENDIF
 p101_UpdGrid()
 chgwater->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Update p100grid1
****************************************************************/
STATIC FUNCTION p101_UpdGrid()
* IF p101_nGrid == 0 must be added else update
IF p101_nGrid == 0
 aTemp := {"", "", CTOD(""), 0, ""}
ELSE
 aTemp := GetProperty( "p100Frm", "grid1", "item", p101_nGrid)
ENDIF
aTemp[1] := p101Frm.chwidaqua.Value
aTemp[2] := p101Frm.taqdescri.Value
aTemp[3] := p101Frm.chwdatech.Value
aTemp[4] := p101Frm.chwliters.Value
aTemp[5] := p101Frm.chwnotess.Value
* IF p101_nGrid == 0 must be added else update
IF p101_nGrid == 0
 DoMethod("p100Frm", "grid1", "additem", aTemp)
 p101_nGrid := GetProperty("p100Frm", "grid1", "ItemCount")
 SetProperty("p100Frm", "grid1", "Value", p101_nGrid )
ELSE
 SetProperty( "p100Frm", "grid1", "item", p101_nGrid, aTemp )
ENDIF

RETURN NIl

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p101_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p101_chwidaqua(), lItsOk)
lItsOk := IF(lItsOk==.T., p101_chwdatech(), lItsOk)
lItsOk := IF(lItsOk==.T., p101_chwliters(), lItsOk)
lItsOk := IF(lItsOk==.T., p101_chwpercen(), lItsOk)
lItsOk := IF(lItsOk==.T., p101_chwnotess(), lItsOk)
RETURN lItsOk

/****************************************************************
* chwidaqua error
****************************************************************/
STATIC FUNCTION p101_chwidaqua()
LOCAL lItsOk := .T.
LOCAL aRetFields := p005_GetRecord( p101Frm.chwidaqua.Value )
IF aRetFields[1] <> p101Frm.chwidaqua.Value
 lItsOk := .F.
 MSGSTOP("Enter a valid code", "p101_chwidaqua()")
 p101Frm.chwidaqua.SetFocus
ELSE
 p101Frm.taqdescri.Value := aRetFields[2]
ENDIF
RETURN lItsOk

/****************************************************************
* chwidaqua finder
****************************************************************/
STATIC FUNCTION p101Src_chwidaqua()
IF p004_Main( {"p101Frm","chwidaqua","chwidaqua"}, p101Frm.chwidaqua.Value)
 p101Frm.Hide
ENDIF
RETURN NIL

/****************************************************************
* chwdatech error
****************************************************************/
STATIC FUNCTION p101_chwdatech()
LOCAL lItsOk := .T.
RETURN lItsOk

/****************************************************************
* chwliters error
****************************************************************/
STATIC FUNCTION p101_chwliters()
LOCAL lItsOk := .T.
LOCAL aRetFields := p005_GetRecord( p101Frm.chwidaqua.Value )
IF p101Frm.chwliters.Value < 0
 lItsOk := .F.
 MSGSTOP("Enter a valid value","p101_chwliters()")
 p101Frm.chwliters.SetFocus
ELSEIF p101Frm.chwliters.Value > aRetFields[17]
 lItsOk := .F.
 MSGSTOP("Max value is " + LTRIM(STR(aRetFields[17])) + " liters","p101_chwliters()")
 p101Frm.chwliters.Value := aRetFields[17]
 p101Frm.chwliters.SetFocus
ELSE
 p101Frm.chwpercen.Value := ROUND( p101Frm.chwliters.Value / aRetFields[17] * 100, 0 )
ENDIF
RETURN lItsOk

/****************************************************************
* chwpercen error
****************************************************************/
STATIC FUNCTION p101_chwpercen()
LOCAL lItsOk := .T.
LOCAL aRetFields := p005_GetRecord( p101Frm.chwidaqua.Value )
IF p101Frm.chwpercen.Value < 0
 lItsOk := .F.
 MSGSTOP("Enter a valid value","p101_chwpercen()")
 p101Frm.chwpercen.SetFocus
ELSE
 p101Frm.chwliters.Value := ROUND( p101Frm.chwpercen.Value * aRetFields[17] / 100, 2 )
ENDIF
RETURN lItsOk

/****************************************************************
* chwnotess error
****************************************************************/
STATIC FUNCTION p101_chwnotess()
LOCAL lItsOk := .T.
RETURN lItsOk

/****************************************************************
* calculate values
****************************************************************/
STATIC FUNCTION p101_chgvalues()
RETURN Nil

/****************************************************************
* public functions
****************************************************************/

/****************************************************************
* return record
****************************************************************/
FUNCTION p101_GetRecord( nGrid )
LOCAL nCurOrd := chgwater->(ORDSETFOCUS(1)), nCurRec := chgwater->(RECNO())
LOCAL cKey := FillKey(nGrid, 8 )
LOCAL aRetFields := {"",CTOD(""),0,0,""}

IF chgwater->(DBSEEK( cKey, .F. ) ) == .T.
 aRetFields[01] := chgwater->chwidaqua
 aRetFields[02] := chgwater->chwdatech
 aRetFields[03] := chgwater->chwliters
 aRetFields[04] := chgwater->chwpercen
 aRetFields[05] := chgwater->chwnotess
ENDIF

chgwater->(ORDSETFOCUS(nCurOrd))
chgwater->(DBGOTO(nCurRec))

RETURN aRetFields